/* routines for Gloe's about box:
 * it mainly pops up and down a motif dialogbox
 *
 * 				p.hlstede 06.09.1997
 */

#include <stdio.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/Form.h>
#include <Xm/Separator.h>
#include <Xm/PushB.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/DrawingA.h>

#include "globals.h"
#include "sys_consts.h"
#include "utils.h"


typedef struct {
   Window        w;
   Display      *disp;
   XtIntervalId  id;
   int           poi;
   int           width, height;
   int           x0,    y0;
   GC		 white;
   GC		 black;
} AnimData;


static void close_dlg(Widget w, XtPointer client_data, XtPointer call_data);
static void destroy_dlg(Widget w, XtPointer client_data, XtPointer call_data);
static void resize_pic(Widget w, XtPointer client_data, XtPointer call_data);
static void redraw_pic(Widget w, XtPointer client_data, XtPointer call_data);
static void animate_about(XtPointer client_data, XtIntervalId *id);


static char *about_msg = "Gloe - Version "VERSION" Rev '"DATE"'\n"
		         "by Franz Gerschwiler (goblin@dcs.qmw.ac.uk)\n"
		         "Copyright Queen Mary and Westfield College, University of London\n"
		         "\n"
	                 "modified by P. Hlstede (peter@calvados.chemie.uni-bremen.de)";

static char points[] = {
	15, 22,   16, 22,   17, 22,   17, 21,   18, 21,   18, 20,   19, 20,   19, 19,
	19, 18,   20, 17,   20, 16,   20, 15,   20, 14,   19, 13,   19, 12,   18, 12,
	17, 11,   16, 11,   15, 11,   14, 11,   13, 11,   12, 11,   11, 12,   10, 12,
	10, 13,    9, 13,    9, 14,    8, 14,    8, 15,    7, 16,    7, 17,    7, 18,
	 7, 19,    6, 20,    6, 21,    6, 22,    6, 23,    6, 24,    6, 25,    6, 26,
	 6, 27,    6, 28,    6, 29,    6, 30,    6, 31,    6, 32,    6, 33,    7, 33,
	 7, 34,    7, 35,    7, 36,    8, 36,    8, 37,    9, 37,    9, 38,   10, 38,
	10, 39,   11, 39,   11, 40,   12, 40,   13, 40,   14, 40,   15, 40,   16, 40,
	17, 40,   17, 39,   18, 39,   18, 38,   19, 38,   19, 37,   19, 36,   19, 35,
	18, 34,   18, 33,   17, 33,   17, 34,   18, 35,   19, 34,   20, 34,   21, 34,
	22, 34,   23, 34,   24, 33,   25, 33,   25, 32,   25, 31,   25, 30,   26, 30,
	26, 29,   26, 28,   26, 27,   26, 26,   26, 25,   27, 25,   27, 24,   27, 23,
	27, 22,   27, 21,   26, 21,   26, 20,   26, 19,   25, 19,   24, 19,   24, 20,
	23, 20,   23, 21,   23, 22,   22, 23,   22, 24,   22, 25,   22, 26,   22, 27,
	22, 28,   23, 28,   23, 29,   23, 30,   23, 31,   23, 32,   23, 33,   24, 34,
	24, 35,   24, 36,   25, 36,   25, 37,   26, 37,   26, 38,   27, 38,   28, 38,
	28, 37,   29, 37,   29, 36,   29, 35,   30, 35,   30, 34,   31, 33,   32, 32,
	33, 32,   34, 32,   33, 32,   32, 32,   32, 33,   32, 34,   31, 34,   31, 35,
	31, 36,   31, 37,   32, 37,   33, 37,   33, 38,   34, 38,   34, 37,   35, 37,
	35, 36,   36, 36,   36, 35,   36, 34,   36, 33,   35, 32,   35, 33,   36, 33,
	37, 33,   38, 33,   38, 34,   39, 34,   40, 34,   41, 34,   42, 34,   42, 33,
	42, 32,   43, 32,   43, 31,   43, 30,   42, 30,   41, 30,   40, 30,   40, 31,
	39, 31,   39, 32,   39, 33,   39, 34,   39, 35,   39, 36,   40, 36,   40, 37,
	41, 37,   42, 37,   43, 37,
	46, 37,
	49, 37,   50, 38,
	 0,  0
};

#define  PIC_WIDTH   56
#define  PIC_HEIGHT  56


static Widget  about_box = (Widget)0;

void  gui_about(void)
{
   Widget         form;
   Widget         form1, sep, form2;
   Widget         lbl, pic, btn;
   XmString       msg;
   AnimData      *anim;
   XGCValues      gc_vals;
   unsigned long  tmp_col;

   if (about_box != (Widget)0)
   {
      XMapRaised(XtDisplay(about_box), XtWindow(about_box));
      return;
   }

   anim = XtNew(AnimData);

   about_box = XtVaCreatePopupShell("About", xmDialogShellWidgetClass, toplevel,
			XmNdeleteResponse, XmDESTROY,
			NULL);

   form = XtVaCreateWidget("form", xmFormWidgetClass, about_box, NULL);

   form1 = XtVaCreateWidget("form1", xmFormWidgetClass, form,
			XmNtopAttachment,   XmATTACH_FORM,
			XmNleftAttachment,  XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			NULL);

   msg = XmStringCreateLtoR(about_msg, CHARSET);
   lbl = XtVaCreateManagedWidget("label", xmLabelWidgetClass, form1,
			XmNlabelString,      msg,
			XmNtopAttachment,    XmATTACH_FORM,
			XmNtopOffset,        10,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNbottomOffset,     10,
			XmNrightAttachment,  XmATTACH_FORM,
			XmNrightOffset,      10,
			NULL);
   XmStringFree(msg);

   pic = XtVaCreateWidget("pic", xmDrawingAreaWidgetClass, form1,
			XmNwidth,            PIC_WIDTH,
			XmNtopAttachment,    XmATTACH_FORM,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNleftAttachment,   XmATTACH_FORM,
			XmNleftOffset,       10,
			XmNrightAttachment,  XmATTACH_WIDGET,
			XmNrightWidget,      lbl,
			XmNrightOffset,      10,
			NULL);

   /* register the resizeCallback before the widgets is managed, else is isn't called !!! */
   XtAddCallback(pic, XmNresizeCallback, resize_pic, (XtPointer)anim);
   XtManageChild(pic);
   XtManageChild(form1);

   sep = XtVaCreateManagedWidget("sep", xmSeparatorWidgetClass, form,
			XmNtopAttachment,   XmATTACH_WIDGET,
			XmNtopWidget,       form1,
			XmNleftAttachment,  XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			NULL);

   form2 = XtVaCreateWidget("form2", xmFormWidgetClass, form,
			XmNfractionBase,     3,
			XmNtopAttachment,    XmATTACH_WIDGET,
			XmNtopWidget,        sep,
			XmNleftAttachment,   XmATTACH_FORM,
			XmNrightAttachment,  XmATTACH_FORM,
			XmNbottomAttachment, XmATTACH_FORM,
			NULL);
   btn = XtVaCreateManagedWidget("ok_button", xmPushButtonWidgetClass, form2,
			XmNtopAttachment,    XmATTACH_FORM,
			XmNtopOffset,        5,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNbottomOffset,     5,
			XmNleftAttachment,   XmATTACH_POSITION,
			XmNleftPosition,     1,
			XmNrightAttachment,  XmATTACH_POSITION,
			XmNrightPosition,    2,
			NULL);
   XtManageChild(form2);
   XtAddCallback(btn, XmNactivateCallback, close_dlg, (XtPointer)about_box);

   XtManageChild(form);

   anim->disp   = XtDisplay(about_box);
   anim->w      = XtWindow(pic);
   anim->poi    = 0;

   XtVaGetValues(pic,
		XmNforeground, &gc_vals.foreground,
		XmNbackground, &gc_vals.background,
		NULL);
   anim->black = XCreateGC(anim->disp, anim->w, GCBackground | GCForeground, &gc_vals);

   tmp_col = gc_vals.foreground;
   gc_vals.foreground = gc_vals.background;
   gc_vals.background = tmp_col;
   anim->white = XCreateGC(anim->disp, anim->w, GCBackground | GCForeground, &gc_vals);

   XtAddCallback(about_box, XmNdestroyCallback, destroy_dlg, (XtPointer)anim);

   XtAddCallback(pic, XmNexposeCallback, redraw_pic, (XtPointer)anim);

   anim->id = XtAppAddTimeOut(app_context, 0, animate_about, (XtPointer)anim);

   XtPopup(about_box, XtGrabNone);
}


static void close_dlg(Widget w, XtPointer client_data, XtPointer call_data)
{
   Widget  shell = (Widget)client_data;
   about_box = (Widget)0;
   XtDestroyWidget(shell);
}


static void destroy_dlg(Widget w, XtPointer client_data, XtPointer call_data)
{
   AnimData  *anim = (AnimData*)client_data;

   XtRemoveTimeOut(anim->id);
   XFreeGC(anim->disp, anim->black);
   XFreeGC(anim->disp, anim->white);
   XtFree((char*)anim);

   set_status_message("");
}


static void resize_pic(Widget w, XtPointer client_data, XtPointer call_data)
{
   AnimData  *anim = (AnimData*)client_data;
   Dimension  width, height;

   XtVaGetValues(w, XmNwidth, &width, XmNheight, &height, NULL);
   anim->width  = width;
   anim->height = height;

   if (anim->width > PIC_WIDTH)
      anim->x0 = (anim->width - PIC_WIDTH) / 2;
   else
      anim->x0 = 0;

   if (anim->height > PIC_HEIGHT)
      anim->y0 = (anim->height - PIC_HEIGHT) / 2;
   else
      anim->y0 = 0;
}


static void redraw_pic(Widget w, XtPointer client_data, XtPointer call_data)
{
   AnimData  *anim = (AnimData*)client_data;
   int        i;

   if (!anim->poi)
   {
      XCopyPlane(anim->disp, gloe_icon, anim->w, anim->black,
			0, 0, PIC_WIDTH, PIC_HEIGHT, anim->x0, anim->y0, 1);
   }
   else
   {
      XFillRectangle(anim->disp, anim->w, anim->white, anim->x0, anim->y0, PIC_WIDTH, PIC_HEIGHT);
      for (i=0; i<anim->poi; i++)
      {
         int  x = points[i * 2];
         int  y = points[i * 2 + 1];
         XDrawPoint(anim->disp, anim->w, anim->black, anim->x0 + x, anim->y0 + y);
      }
   }
}


static void animate_about(XtPointer client_data, XtIntervalId *id)
{
   AnimData  *anim = (AnimData*)client_data;
   int        x, y, i;
   long       wait_time;

   if (!anim->poi)
   {
      XFillRectangle(anim->disp, anim->w, anim->white, anim->x0, anim->y0, PIC_WIDTH, PIC_HEIGHT);
      wait_time = 500;
      anim->poi++;
   }
   else
   {
      i = (anim->poi - 1) * 2;
      x = points[i++];
      if (!x)
      {
         anim->poi = 0;
         wait_time = 3000;
      }
      else
      {
         y = points[i];
         XDrawPoint(anim->disp, anim->w, anim->black, anim->x0 + x, anim->y0 + y);
         wait_time = 50;
         anim->poi++;
      }
   }

   anim->id = XtAppAddTimeOut(app_context, wait_time, animate_about, (XtPointer)anim);
}
